aarch64: ensure objects are BTI compatible

System Internals / glibc - Szabolcs Nagy [arm.com] - 8 July 2020 14:02 UTC

When glibc is built with branch protection (i.e. with a gcc configured with --enable-standard-branch-protection), all glibc binaries should be BTI compatible and marked as such.

It is easy to link BTI incompatible objects by accident and this is silent currently which is usually not the expectation, so this is changed into a link error. (There is no linker flag for failing on BTI incompatible inputs so all warnings are turned into fatal errors outside the test system when building glibc with branch protection.)

Unfortunately, outlined atomic functions are not BTI compatible in libgcc (PR libgcc/96001), so to build glibc with current gcc use 'CC=gcc -mno-outline-atomics', this should be fixed in libgcc soon and then glibc can be built and tested without such workarounds.

de9301c02e aarch64: ensure objects are BTI compatible
sysdeps/aarch64/Makefile | 8 ++++++++
sysdeps/aarch64/configure | 2 ++
sysdeps/aarch64/configure.ac | 1 +
3 files changed, 11 insertions(+)

Upstream: sourceware.org


  • Share